# -*- coding: utf-8 -*-
def LD(s,t):
    s = ' ' + s
    t = ' ' + t
    d = {}
    S = len(s)
    T = len(t)
    for i in range(S):
        d[i, 0] = i
    for j in range (T):
        d[0, j] = j
    for j in range(1,T):
        for i in range(1,S):
            if s[i] == t[j]:
                d[i, j] = d[i-1, j-1]
            else:
                d[i, j] = min(d[i-1, j] + 1, d[i, j-1] + 1, d[i-1, j-1] + 1)
    return d[S-1, T-1]

swedish = [u"a", u"b", u"c", u"d", u"e", u"f", u"g", u"h", u"i", u"j", u"k", u"l", u"m", u"n", u"o", u"p", u"r", u"s", u"t", u"u", u"v", u"x", u"y", u"z", u"å", u"ä", u"ö", u"", u", u", u" "]
def generateLDOneWords(word):
    generatedSoFarForTotal = []
    for letterNumber in range(0, len(word) + 1):
        generateForLetterNumber(word, letterNumber, generatedSoFarForTotal)
    #for el in generatedSoFarForTotal:
    #    print "*", el, LD(el,word)
    return generatedSoFarForTotal
    #for letter in word:
        #print letter

def generateForLetterNumber(word, number, generatedSoFar):
    for el in swedish:
        if number < len(word):
            newWord = word[:number] + el + word[number + 1:]
            generatedSoFar.append(newWord)

        newWordLonger = word[:number] + el + word[number:]
        generatedSoFar.append(newWordLonger)

#print "**************************"
#print generateLDOneWords("hej")
#print generateLDOneWords("linsskala")
#print LD("hej", "hej")
#print LD("hej", "hel")
#print LD("hej", "he")
#print LD("hej", "aaa")


""""
def generateLDWords(word, distance):
    generatedSoFarForTotal = []
    for letterNumber in range(0, len(word)):
        generatedSoFarForLetter = []
        nrOfIterations = 0
        toGenerateFrom = [word]
        while(nrOfIterations < distance and nrOfIterations + letterNumber < len(word)):
            for el in toGenerateFrom:
                generateForLetterNumber(el, nrOfIterations + letterNumber, generatedSoFarForLetter)
            toGenerateFrom = generatedSoFarForLetter
            nrOfIterations = nrOfIterations + 1
        generatedSoFarForTotal = generatedSoFarForTotal + generatedSoFarForLetter
    for el in generatedSoFarForTotal:
        print el, LD(el,word)
    #for letter in word:
        #print letter
"""
