import csv
import commands

inputfilename = "conllinput.txt"

def askConllScript(outputdata, resultForConllOutputFile):
    print "Using conll script for file: ", outputdata
    conllCommand = "./conlleval.pl -d '\t' < " + outputdata
    print "Running command " + conllCommand
    conllOutput = commands.getoutput(conllCommand).split('\n')
    open(resultForConllOutputFile, "w").write(str(conllOutput))
    #for line in testresults:
    #    print line
    #exit(1)
    returndict = {}
    #conllOutput = open(inputfilename, "r").readlines()
    for line in conllOutput:
        if line.find("precision") != -1 and line.find("accuracy") == -1:
            splitted =  line.split(":")
            tagname = splitted[0].strip()
            precision = float(splitted[2].split(";")[0].strip().replace("%", ""))/100
            recall = float(splitted[3].split(";")[0].strip().replace("%", ""))/100
            foundGuessed = splitted[5].split(";")[0]
            foundCorrect = splitted[6].strip()
            returndict[tagname] = [precision, recall, foundGuessed, foundCorrect]
        else:
            print "Does not use: ",  line
    return returndict
        
#dict = askConllScript("outputdata/test_IB.output", "outputdata")

#print dict
